import { world, Player } from '@minecraft/server';
// code working for cps and reach display, also combo counter
const clicks = new Map();
export function getPlayerCPS(player) {
    const currentTime = Date.now();
    const playerClicks = clicks.get(player) || [];
    const recentClicks = playerClicks.filter(({ timestamp }) => currentTime - 1000 < timestamp);
    clicks.set(player, recentClicks);
    return recentClicks.length;
};

world.afterEvents.entityHitEntity.subscribe(function ({ damagingEntity }) {
  if (!(damagingEntity instanceof Player))
    return;
  const clickInfo = { timestamp: Date.now() };
  const playerClicks = clicks.get(damagingEntity) || [];
  playerClicks.push(clickInfo);
  clicks.set(damagingEntity, playerClicks);
           //

           //
  const reacher = world.afterEvents.entityHurt.subscribe(({ hurtEntity, damageSource, damage }) => {
  const botloc = damageSource.damagingEntity.location
  const playerloc = hurtEntity.location
   const direction = {
    x: playerloc.x - botloc.x,
    y: playerloc.y - botloc.y,
    z: playerloc.z - botloc.z
  };
   function distance(direction) {
    var direction = Math.sqrt(Math.pow(direction.x, 2) + Math.pow(direction.y, 2) + Math.pow(direction.z, 2));
    var num = direction - 0.9
   if (num <= 3) {
   num = Math.abs(Math.ceil(num * 10) / 10);
  }
  else {
  num = 3
  }
  return num
  };
  const players = world.getAllPlayers();
    for (const player of players) {
      const combo = world.scoreboard.getObjective("combocount");
      const combocounter = combo.getScore(player);
      // 1 option
      if (hurtEntity.typeId !== "minecraft:player" && player.hasTag("cps") && !player.hasTag("reach") && !player.hasTag("comboo")) {  
   player.onScreenDisplay.setActionBar(`§eCPS§8:§r ${getPlayerCPS(player)}`);
   }
      if (hurtEntity.typeId !== "minecraft:player" && player.hasTag("reach") && !player.hasTag("cps") && !player.hasTag("comboo")) {
  player.onScreenDisplay.setActionBar(`§eReach§8:§r ${distance(direction)}`);
   }
      if (hurtEntity.typeId !== "minecraft:player" && !player.hasTag("cps") && !player.hasTag("reach") && player.hasTag("comboo")) {  
    player.onScreenDisplay.setActionBar(`§eCombo§8:§r ${combocounter}`);
    }
      // 2 options
      if (hurtEntity.typeId !== "minecraft:player" && player.hasTag("cps") && !player.hasTag("comboo") && player.hasTag("reach")) {
  player.onScreenDisplay.setActionBar(`§eCPS§8:§r ${getPlayerCPS(player)} §8| §eReach§8:§r ${distance(direction)}`);
}
      if (hurtEntity.typeId !== "minecraft:player" && !player.hasTag("cps") && player.hasTag("comboo") && player.hasTag("reach")) {
  player.onScreenDisplay.setActionBar(`§eCombo§8:§r ${combocounter} §8| §eReach§8:§r ${distance(direction)}`);
}
      if (hurtEntity.typeId !== "minecraft:player" && player.hasTag("cps") && player.hasTag("comboo") && !player.hasTag("reach")) {
  player.onScreenDisplay.setActionBar(`§eCPS§8:§r ${getPlayerCPS(player)} §8| §eCombo§8:§r ${combocounter}`);
}
      // 3 options
      if (hurtEntity.typeId !== "minecraft:player" && player.hasTag("cps") && player.hasTag("comboo") && player.hasTag("reach")) {
  player.onScreenDisplay.setActionBar(`§eCPS§8:§r ${getPlayerCPS(player)} §8| §eCombo§8:§r ${combocounter} §8| §eReach§8:§r ${distance(direction)}`);
}
  world.afterEvents.entityHurt.unsubscribe(reacher);
    };
  });
});