import {world} from "@minecraft/server";

world.beforeEvents.chatSend.subscribe((eventData) => {
    const player = eventData.sender;
    const message = eventData.message;
    if (message != "!hub") return;
    eventData.cancel = true;
    player.runCommandAsync('tag @e[tag=npc3] remove follow')
    player.runCommandAsync('tp @e[tag=npc3] 10 0 -1')
    player.runCommandAsync('execute as @e[type=player,tag=!duel] run tp @e[type=da1:pvpbot] 0 25 0')
    player.runCommandAsync('tp @e[type=player,tag=!duel] 0 30 0 facing 0 30 -1')
    player.runCommandAsync('tellraw @e[type=player,tag=!duel] {"rawtext":[{"text":"§aSuccessfully back to hub!"}]}')
    player.runCommandAsync('tellraw @e[type=player,tag=duel] {"rawtext":[{"text":"§cUnable to execute command in duel!"}]}');
});