import { world, system } from '@minecraft/server';

world.afterEvents.entityHurt.subscribe(({ hurtEntity, damageSource, damage }) => {  
  for (const player of world.getPlayers()) {
  if ((hurtEntity.typeId == "minecraft:player" || hurtEntity.typeId == "minecraft:ender_pearl") &&
  damageSource.damagingEntity.typeId  == "da1:pvpbot" &&
  damage !=0 ) return;
  if (player.hasTag("clutch")) return;
  player.runCommandAsync('scoreboard players add @p combocount 1')
  const botloc = damageSource.damagingEntity.location
  const playerloc = hurtEntity.location
  const directionX = playerloc.x - botloc.x
  const directionZ = playerloc.z - botloc.z
  const magnitude = Math.sqrt(directionX * directionX + directionZ * directionZ)
  const newdirX = directionX / magnitude
  const newdirZ = directionZ / magnitude
  hurtEntity.clearVelocity();
  damageSource.damagingEntity.addEffect("weakness", 8, { amplifier: 255, showParticles: false });
  if (damage >= 1) {
  player.runCommandAsync('scoreboard players add @e[type=player] hit 1')
  player.runCommandAsync('scoreboard players add @e[type=player] hit2 1')
  }
  hurtEntity.applyImpulse({ x: newdirX / 3.27, y: 0.36, z: newdirZ / 3.27 });
  }
});