import { world, system } from '@minecraft/server';

system.runInterval(() => {
  for (const player of world.getPlayers()) {        
    var hitbox=player.isSprinting
    if (!hitbox && player.hasTag("clutch")) {     
      let hitboxwidth = player.getComponent( 'minecraft:collision_box' )
      hitboxwidth.setCurrentValue( 5000 )   
    }
  }
});

//normal kb
world.afterEvents.entityHurt.subscribe(({ hurtEntity, damageSource, damage }) => {
  for (const player of world.getPlayers()) {  
    const b=player.isOnGround
    const a=player.hasTag("clutch")
    if (                                                            
    hurtEntity.typeId == "da1:pvpbot" &&
    damageSource.damagingEntity.typeId  == "minecraft:player" &&
    damage != 0
  ) return;
  player.runCommandAsync('scoreboard players set @p combocount 1')
  const botloc = damageSource.damagingEntity.location
  const playerloc = hurtEntity.location
  const directionX = playerloc.x - botloc.x
  const directionZ = playerloc.z - botloc.z
  const magnitude = Math.sqrt(directionX * directionX + directionZ * directionZ)
  const newdirX = directionX / magnitude
  const newdirZ = directionZ / magnitude
  player.runCommandAsync('scoreboard players add @e[type=da1:pvpbot] hit 1')
  player.runCommandAsync('scoreboard players add Opponent hit2 1')
  if (!a && b) {
    hurtEntity.applyKnockback( newdirX, newdirZ, 0.33, .39)
    break;
  } else if (!a && !b) {
    hurtEntity.applyKnockback( newdirX, newdirZ, 0.58, .39)
    break;
    } else {
    hurtEntity.applyKnockback( newdirX, newdirZ, 0.63, .41)
    }
    break;
  }  
});