import { world, system } from "@minecraft/server";

Math.ceil
Math.floor

function generateRandomNumber(min, max) {
  return ((Math.random()) * (max - min + 1) + min).toFixed(2)
}

let oppoelo = 0;

function getplayerelo(world) {
  for (const player of world.getPlayers()) { 
  var getelo = world.scoreboard.getObjective("elo");
  return getelo.getScore(player)
  }
}

let playerelo = 0;

function calculaterate(playerelo, oppoelo) {
  return (1 / ( 1 + Math.pow(10, (oppoelo - playerelo) / 400))).toFixed(2)
}

function calculateopporate(playerelo, oppoelo) {
  return (1 - calculaterate(playerelo, oppoelo)).toFixed(2)
}

let playerwinrate = 0;
let oppowinrate = 0

function winplayerelo(playerelo, playerwinrate) {
  return Math.round(playerelo + 32 * (1 - playerwinrate))
}

function loseplayerelo(playerelo, playerwinrate) {
  return Math.round(playerelo - 32 * (playerwinrate))
}

function winoppoelo(oppoelo, oppowinrate) {
  return Math.round(oppoelo + 32 * (1 - oppowinrate))
}

function loseoppoelo(oppoelo, oppowinrate) {
  return Math.round(oppoelo - 32 * (oppowinrate))
}

let score1 = 0
let score2 = 0
let score3 = 0
let score4 = 0

world.afterEvents.entitySpawn.subscribe(evt => {
  const target = evt.entity;
  if (target.typeId === "minecraft:arrow") {
    for (const player of world.getPlayers()) { 
    const randomNumber = Math.floor(10 * generateRandomNumber(-50, 50));
    oppoelo = 1000 + randomNumber
    playerelo = getplayerelo(world)
    playerwinrate = calculaterate(playerelo, oppoelo)
    oppowinrate = calculateopporate(playerelo, oppoelo)
    system.runTimeout(() => {
      player.runCommandAsync('playsound random.click @p')
      player.sendMessage(`§dYour opponent has a §eRating §dof §e${oppoelo}.§r`)
      }, 160);
    }
  }
  // win
  if (target.typeId === "minecraft:snowball") {
    for (const player of world.getPlayers()) { 
    score1 = winplayerelo(playerelo, playerwinrate)
    score4 = loseoppoelo(oppoelo, oppowinrate)
    player.runCommandAsync(`scoreboard players set @p elo ${score1}`)
    system.runTimeout(() => {
      player.runCommandAsync('playsound random.click @p')
      player.sendMessage(`§eELO Updates: §aYou ${score1} (+${Math.round(32 * (1 - playerwinrate))})§e, §cOpponent ${score4} (-${Math.round(32 * oppowinrate)})`)
      }, 60);
    }
  }
  //lose
  if (target.typeId === "minecraft:egg") {
    for (const player of world.getPlayers()) { 
    score2 = loseplayerelo(playerelo, playerwinrate)
    score3 = winoppoelo(oppoelo, oppowinrate)
    player.runCommandAsync(`scoreboard players set @p elo ${score2}`)
    system.runTimeout(() => {
      player.runCommandAsync('playsound random.click @p')
      player.sendMessage(`§eELO Updates: §aOpponent ${score3} (+${Math.round(32 * (1 - oppowinrate))})§e, §cYou ${score2} (-${Math.round(32 * playerwinrate)})`)
      }, 60);
    }
  }
})